diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-mlo-test.cc ns-3.40/src/wifi/test/wifi-mlo-test.cc
--- ns-3.39/src/wifi/test/wifi-mlo-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-mlo-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -882,45 +1293,113 @@
         NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
                               false,
                               "Multi-Link Element in Assoc Request frame from single link STA");
-        return;
     }
-
-    NS_TEST_EXPECT_MSG_EQ(mle.has_value(), true, "No Multi-Link Element in Assoc Request frame");
-    NS_TEST_EXPECT_MSG_EQ(mle->GetMldMacAddress(),
-                          m_staMacs[0]->GetAddress(),
-                          "Incorrect MLD Address advertised in Multi-Link Element");
-    NS_TEST_EXPECT_MSG_EQ(mle->GetNPerStaProfileSubelements(),
-                          m_setupLinks.size() - 1,
-                          "Incorrect number of Per-STA Profile subelements in Multi-Link Element");
-    for (std::size_t i = 0; i < mle->GetNPerStaProfileSubelements(); i++)
+    else
     {
-        auto& perStaProfile = mle->GetPerStaProfile(i);
-        NS_TEST_EXPECT_MSG_EQ(perStaProfile.HasStaMacAddress(),
-                              true,
-                              "Per-STA Profile must contain STA MAC address");
-        // find ID of the local link corresponding to this subelement
-        auto staLinkId = m_staMacs[0]->GetLinkIdByAddress(perStaProfile.GetStaMacAddress());
-        NS_TEST_EXPECT_MSG_EQ(
-            staLinkId.has_value(),
-            true,
-            "No link found with the STA MAC address advertised in Per-STA Profile");
-        NS_TEST_EXPECT_MSG_NE(
-            +staLinkId.value(),
-            +linkId,
-            "The STA that sent the Assoc Request should not be included in a Per-STA Profile");
-        auto it = std::find_if(m_setupLinks.begin(), m_setupLinks.end(), [&staLinkId](auto&& pair) {
-            return pair.first == staLinkId.value();
-        });
-        NS_TEST_EXPECT_MSG_EQ((it != m_setupLinks.end()),
+        NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
                               true,
-                              "Not expecting to setup STA link ID " << +staLinkId.value());
+                              "No Multi-Link Element in Assoc Request frame");
+        NS_TEST_EXPECT_MSG_EQ(mle->GetMldMacAddress(),
+                              m_staMacs[0]->GetAddress(),
+                              "Incorrect MLD Address advertised in Multi-Link Element");
         NS_TEST_EXPECT_MSG_EQ(
-            +it->second,
-            +perStaProfile.GetLinkId(),
-            "Not expecting to request association to AP Link ID in Per-STA Profile");
-        NS_TEST_EXPECT_MSG_EQ(perStaProfile.HasAssocRequest(),
+            mle->GetNPerStaProfileSubelements(),
+            m_setupLinks.size() - 1,
+            "Incorrect number of Per-STA Profile subelements in Multi-Link Element");
+        for (std::size_t i = 0; i < mle->GetNPerStaProfileSubelements(); i++)
+        {
+            auto& perStaProfile = mle->GetPerStaProfile(i);
+            NS_TEST_EXPECT_MSG_EQ(perStaProfile.HasStaMacAddress(),
+                                  true,
+                                  "Per-STA Profile must contain STA MAC address");
+            // find ID of the local link corresponding to this subelement
+            auto staLinkId = m_staMacs[0]->GetLinkIdByAddress(perStaProfile.GetStaMacAddress());
+            NS_TEST_EXPECT_MSG_EQ(
+                staLinkId.has_value(),
+                true,
+                "No link found with the STA MAC address advertised in Per-STA Profile");
+            NS_TEST_EXPECT_MSG_NE(
+                +staLinkId.value(),
+                +linkId,
+                "The STA that sent the Assoc Request should not be included in a Per-STA Profile");
+            auto it = std::find(m_setupLinks.begin(), m_setupLinks.end(), staLinkId.value());
+            NS_TEST_EXPECT_MSG_EQ((it != m_setupLinks.end()),
+                                  true,
+                                  "Not expecting to setup STA link ID " << +staLinkId.value());
+            NS_TEST_EXPECT_MSG_EQ(
+                +staLinkId.value(),
+                +perStaProfile.GetLinkId(),
+                "Not expecting to request association to AP Link ID in Per-STA Profile");
+            NS_TEST_EXPECT_MSG_EQ(perStaProfile.HasAssocRequest(),
+                                  true,
+                                  "Missing Association Request in Per-STA Profile");
+        }
+    }
+
+    const auto& tlm = assoc.Get<TidToLinkMapping>();
+
+    // A TID-to-Link Mapping IE is included in the Association Request if and only if the AP MLD
+    // and the non-AP MLD are performing ML setup (i.e., they both have multiple links) and the
+    // AP MLD advertises a non-null negotiation support type
+    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1 || m_apNegSupport == 0)
+    {
+        NS_TEST_EXPECT_MSG_EQ(tlm.empty(),
                               true,
-                              "Missing Association Request in Per-STA Profile");
+                              "Didn't expect a TID-to-Link Mapping IE in Assoc Request frame");
+    }
+    else
+    {
+        std::size_t expectedNTlm = (m_dlTidLinkMapping == m_ulTidLinkMapping ? 1 : 2);
+
+        NS_TEST_ASSERT_MSG_EQ(tlm.size(),
+                              expectedNTlm,
+                              "Unexpected number of TID-to-Link Mapping IE in Assoc Request");
+
+        // lambda to check content of TID-to-Link Mapping IE(s)
+        auto checkTlm = [&](std::size_t tlmId, WifiDirection dir) {
+            NS_TEST_EXPECT_MSG_EQ(+static_cast<uint8_t>(tlm[tlmId].m_control.direction),
+                                  +static_cast<uint8_t>(dir),
+                                  "Unexpected direction in TID-to-Link Mapping IE " << tlmId);
+            auto& expectedMapping =
+                (dir == WifiDirection::UPLINK ? m_ulTidLinkMapping : m_dlTidLinkMapping);
+
+            NS_TEST_EXPECT_MSG_EQ(tlm[tlmId].m_control.defaultMapping,
+                                  expectedMapping.empty(),
+                                  "Default Link Mapping bit not set correctly");
+            NS_TEST_EXPECT_MSG_EQ(tlm[tlmId].m_linkMapping.size(),
+                                  expectedMapping.size(),
+                                  "Unexpected number of Link Mapping Of TID n fields");
+            for (uint8_t tid = 0; tid < 8; tid++)
+            {
+                if (auto it = expectedMapping.find(tid); it != expectedMapping.cend())
+                {
+                    NS_TEST_EXPECT_MSG_EQ((tlm[tlmId].GetLinkMappingOfTid(tid) == it->second),
+                                          true,
+                                          "Unexpected link mapping for TID "
+                                              << +tid << " direction " << dir);
+                }
+                else
+                {
+                    NS_TEST_EXPECT_MSG_EQ(tlm[tlmId].GetLinkMappingOfTid(tid).empty(),
+                                          true,
+                                          "Expecting no Link Mapping Of TID n field for TID "
+                                              << +tid << " direction " << dir);
+                }
+            }
+        };
+
+        if (tlm.size() == 1)
+        {
+            checkTlm(0, WifiDirection::BOTH_DIRECTIONS);
+        }
+        else
+        {
+            std::size_t dlId = (tlm[0].m_control.direction == WifiDirection::DOWNLINK ? 0 : 1);
+            std::size_t ulId = (dlId == 0 ? 1 : 0);
+
+            checkTlm(dlId, WifiDirection::DOWNLINK);
+            checkTlm(ulId, WifiDirection::UPLINK);
+        }
     }
 }
 
@@ -974,9 +1453,7 @@
             +apLinkId.value(),
             +linkId,
             "The AP that sent the Assoc Response should not be included in a Per-STA Profile");
-        auto it = std::find_if(m_setupLinks.begin(), m_setupLinks.end(), [&apLinkId](auto&& pair) {
-            return pair.second == apLinkId.value();
-        });
+        auto it = std::find(m_setupLinks.begin(), m_setupLinks.end(), apLinkId.value());
         NS_TEST_EXPECT_MSG_EQ((it != m_setupLinks.end()),
                               true,
                               "Not expecting to setup AP link ID " << +apLinkId.value());
@@ -984,6 +1461,12 @@
                               true,
                               "Missing Association Response in Per-STA Profile");
     }
+
+    // For the moment, the AP MLD always accepts a valid TID-to-Link Mapping request, hence
+    // in every case there is no TID-to-Link Mapping IE in the Association Response
+    NS_TEST_EXPECT_MSG_EQ(assoc.Get<TidToLinkMapping>().empty(),
+                          true,
+                          "Didn't expect to find a TID-to-Link Mapping IE in Association Response");
 }
 
 void
@@ -994,8 +1477,11 @@
      */
     NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->IsAssociated(), true, "Expected the STA to be associated");
 
-    for (const auto& [staLinkId, apLinkId] : m_setupLinks)
+    for (const auto linkId : m_setupLinks)
     {
+        auto staLinkId = (m_staMacs[0]->GetNLinks() > 1 ? linkId : SINGLE_LINK_OP_ID);
+        auto apLinkId = (m_apMac->GetNLinks() > 1 ? linkId : SINGLE_LINK_OP_ID);
+
         auto staAddr = m_staMacs[0]->GetFrameExchangeManager(staLinkId)->GetAddress();
         auto apAddr = m_apMac->GetFrameExchangeManager(apLinkId)->GetAddress();
 
@@ -1060,16 +1546,49 @@
             +m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetPrimaryChannelIndex(20),
             "Incorrect operating primary channel index for STA on link " << +staLinkId);
     }
+
+    // lambda to check the link mapping stored at wifi MAC
+    auto checkStoredMapping =
+        [this](Ptr<WifiMac> mac, Ptr<WifiMac> dest, WifiDirection dir, bool present) {
+            NS_TEST_ASSERT_MSG_EQ(mac->GetTidToLinkMapping(dest->GetAddress(), dir).has_value(),
+                                  present,
+                                  "Link mapping stored by "
+                                      << (mac->GetTypeOfStation() == AP ? "AP" : "non-AP")
+                                      << " MLD for " << dir << " direction "
+                                      << (present ? "expected" : "not expected"));
+            if (present)
+            {
+                const auto& mapping =
+                    (dir == WifiDirection::DOWNLINK ? m_dlTidLinkMapping : m_ulTidLinkMapping);
+                NS_TEST_EXPECT_MSG_EQ(
+                    (mac->GetTidToLinkMapping(dest->GetAddress(), dir)->get() == mapping),
+                    true,
+                    "Incorrect link mapping stored by "
+                        << (mac->GetTypeOfStation() == AP ? "AP" : "non-AP") << " MLD for " << dir
+                        << " direction");
+            }
+        };
+
+    auto storedMapping =
+        m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1 && m_apNegSupport > 0;
+    checkStoredMapping(m_apMac, m_staMacs[0], WifiDirection::DOWNLINK, storedMapping);
+    checkStoredMapping(m_apMac, m_staMacs[0], WifiDirection::UPLINK, storedMapping);
+    checkStoredMapping(m_staMacs[0], m_apMac, WifiDirection::DOWNLINK, storedMapping);
+    checkStoredMapping(m_staMacs[0], m_apMac, WifiDirection::UPLINK, storedMapping);
 }
 
 void
 MultiLinkSetupTest::CheckDisabledLinks()
 {
-    for (std::size_t linkId = 0; linkId < m_staChannels.size(); linkId++)
+    if (m_staMacs[0]->GetNLinks() == 1)
     {
-        auto it = std::find_if(m_setupLinks.begin(), m_setupLinks.end(), [&linkId](auto&& link) {
-            return link.first == linkId;
-        });
+        // no link is disabled on a single link device
+        return;
+    }
+
+    for (const auto& linkId : m_staMacs[0]->GetLinkIds())
+    {
+        auto it = std::find(m_setupLinks.begin(), m_setupLinks.end(), linkId);
         if (it == m_setupLinks.end())
         {
             // the link has not been setup
@@ -1086,6 +1605,146 @@
     }
 }
 
+void
+MultiLinkSetupTest::CheckQosData(Ptr<WifiMpdu> mpdu, uint8_t linkId, std::size_t index)
+{
+    WifiDirection dir;
+    const auto& hdr = mpdu->GetHeader();
+
+    NS_TEST_ASSERT_MSG_EQ(hdr.IsQosData(), true, "Expected a QoS data frame");
+
+    if (!hdr.IsToDs() && hdr.IsFromDs())
+    {
+        dir = WifiDirection::DOWNLINK;
+    }
+    else if (hdr.IsToDs() && !hdr.IsFromDs())
+    {
+        dir = WifiDirection::UPLINK;
+    }
+    else
+    {
+        NS_ABORT_MSG("Invalid combination for QoS data frame: ToDS(" << hdr.IsToDs() << ") FromDS("
+                                                                     << hdr.IsFromDs() << ")");
+    }
+
+    const auto& tid1 = (dir == WifiDirection::DOWNLINK) ? m_dlTid1 : m_ulTid1;
+    const auto& tid2 = (dir == WifiDirection::DOWNLINK) ? m_dlTid2 : m_ulTid2;
+    uint8_t tid = hdr.GetQosTid();
+
+    NS_TEST_ASSERT_MSG_NE((tid == tid1),
+                          (tid2.has_value() && tid == *tid2),
+                          "QoS frame with unexpected TID " << +tid);
+
+    // lambda to find the link set the given TID is mapped to
+    auto findLinkSet = [this, dir](uint8_t tid) -> std::set<uint8_t> {
+        std::set<uint8_t> linkSet(m_setupLinks.cbegin(), m_setupLinks.cend());
+        if (auto mappingOptRef = m_apMac->GetTidToLinkMapping(m_staMacs[0]->GetAddress(), dir))
+        {
+            // if the TID is not present in the mapping, it is mapped to all setup links
+            if (auto it = mappingOptRef->get().find(tid); it != mappingOptRef->get().cend())
+            {
+                linkSet = it->second;
+                NS_ASSERT_MSG(!linkSet.empty(), "TID " << +tid << " mapped to no link");
+            }
+        }
+        return linkSet;
+    };
+
+    auto linkSet = findLinkSet(tid);
+    auto& qosFrames = (tid == tid1) ? m_qosFrames1 : m_qosFrames2;
+
+    // Let N the size of the link set, the first N QoS data frames are sent simultaneously
+    // on the links of the set, the others (if any) will be sent afterwards on such links
+
+    // number of concurrent frames of the same TID transmitted so far (excluding current frame)
+    std::size_t nConcurFrames = std::min(qosFrames.size(), linkSet.size());
+
+    // iterate over the concurrent frames of the same TID transmitted so far
+    for (std::size_t i = 0; i < nConcurFrames; i++)
+    {
+        auto prev = qosFrames[i];
+
+        // TX duration of i-th frame
+        auto band = m_apMac->GetWifiPhy(m_txPsdus[prev].linkId)->GetPhyBand();
+        Time txDuration =
+            WifiPhy::CalculateTxDuration(m_txPsdus[prev].psduMap, m_txPsdus[prev].txVector, band);
+
+        // the current frame is transmitted concurrently with this previous frame if it is
+        // within the first N (size of the link set) frames, otherwise it is transmitted after
+        // this previous frame if they have been transmitted on the same link
+        if (qosFrames.size() < linkSet.size())
+        {
+            // the current frame can be sent concurrently with this previous frame
+            NS_TEST_EXPECT_MSG_LT(m_txPsdus[index].startTx,
+                                  m_txPsdus[prev].startTx + txDuration,
+                                  "The " << dir << " QoS frame number " << qosFrames.size()
+                                         << " was not sent concurrently with others on link "
+                                         << +linkId << " which TID " << +tid << " is mapped to");
+        }
+        else if (m_txPsdus[prev].linkId == linkId)
+        {
+            // the current  frame is sent afterwards
+            NS_TEST_EXPECT_MSG_GT(m_txPsdus[index].startTx,
+                                  m_txPsdus[prev].startTx + txDuration,
+                                  "The " << dir << " QoS frame number " << qosFrames.size()
+                                         << " was sent concurrently with others on a link "
+                                         << +linkId << " which TID " << +tid << " is mapped to");
+        }
+    }
+
+    if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
+    {
+        NS_TEST_EXPECT_MSG_EQ(std::count(linkSet.cbegin(), linkSet.cend(), linkId),
+                              1,
+                              "QoS frame sent on Link ID "
+                                  << +linkId << " that does not belong to the link set of TID "
+                                  << +tid);
+    }
+
+    if (tid2)
+    {
+        // QoS frames of two distinct TIDs are sent.
+        auto otherTid = (tid == tid1) ? *tid2 : tid1;
+        const auto& otherQosFrames = (tid == tid1) ? m_qosFrames2 : m_qosFrames1;
+        auto otherLinkSet = findLinkSet(otherTid);
+
+        // number of concurrent frames of the other TID transmitted so far
+        std::size_t nOtherConcurFrames = std::min(otherQosFrames.size(), otherLinkSet.size());
+
+        // iterate over the concurrent frames of the other TID
+        for (std::size_t i = 0; i < nOtherConcurFrames; i++)
+        {
+            auto prev = otherQosFrames[i];
+
+            // TX duration of i-th frame
+            auto band = m_apMac->GetWifiPhy(m_txPsdus[prev].linkId)->GetPhyBand();
+            Time txDuration = WifiPhy::CalculateTxDuration(m_txPsdus[prev].psduMap,
+                                                           m_txPsdus[prev].txVector,
+                                                           band);
+
+            // the current frame is transmitted concurrently with this previous frame of the
+            // other TID if it is within the first N (size of the link set) frames of its TID
+            if (qosFrames.size() < linkSet.size())
+            {
+                // the current frame can be sent concurrently with this previous frame
+                NS_TEST_EXPECT_MSG_LT(m_txPsdus[index].startTx,
+                                      m_txPsdus[prev].startTx + txDuration,
+                                      "The " << dir << " QoS frame number " << qosFrames.size()
+                                             << " was not sent concurrently with others with TID "
+                                             << +otherTid);
+            }
+        }
+    }
+
+    // insert the frame
+    qosFrames.emplace_back(index);
+
+    if (qosFrames.size() == m_setupLinks.size())
+    {
+        qosFrames.clear();
+    }
+}
+
 /**
  * Tested traffic patterns.
  */
@@ -1150,34 +1809,22 @@
     /**
      * Constructor
      *
+     * \param baseParams common configuration parameters
      * \param trafficPattern the pattern of traffic to generate
      * \param baEnabled whether BA agreement is enabled or disabled
      * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
      * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
      *                     (unused if Block Ack agreements are not established)
-     * \param staChannels the strings specifying the operating channels for the STA
-     * \param apChannels the strings specifying the operating channels for the AP
-     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
      */
-    MultiLinkTxTest(WifiTrafficPattern trafficPattern,
+    MultiLinkTxTest(const BaseParams& baseParams,
+                    WifiTrafficPattern trafficPattern,
                     WifiBaEnabled baEnabled,
                     WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                    uint8_t nMaxInflight,
-                    const std::vector<std::string>& staChannels,
-                    const std::vector<std::string>& apChannels,
-                    const std::vector<uint8_t>& fixedPhyBands = {});
+                    uint8_t nMaxInflight);
     ~MultiLinkTxTest() override = default;
 
   protected:
     /**
-     * Function to trace packets received by the server application
-     * \param nodeId the ID of the node that received the packet
-     * \param p the packet
-     * \param addr the address
-     */
-    void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
-
-    /**
      * Check the content of a received BlockAck frame when the max number of links on which
      * an MPDU can be inflight is one.
      *
@@ -1187,8 +1834,8 @@
      */
     void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
 
-    void Transmit(uint8_t linkId,
-                  std::string context,
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
                   WifiConstPsduMap psduMap,
                   WifiTxVector txVector,
                   double txPowerW) override;
@@ -1201,30 +1848,26 @@
     /// Receiver address-indexed map of list error models
     using RxErrorModelMap = std::unordered_map<Mac48Address, Ptr<ListErrorModel>, WifiAddressHash>;
 
-    RxErrorModelMap m_errorModels;         ///< error rate models to corrupt packets
-    std::list<uint64_t> m_uidList;         ///< list of UIDs of packets to corrupt
-    bool m_dataCorrupted{false};           ///< whether second data frame has been already corrupted
-    WifiTrafficPattern m_trafficPattern;   ///< the pattern of traffic to generate
-    bool m_baEnabled;                      ///< whether BA agreement is enabled or disabled
-    bool m_useBarAfterMissedBa;            ///< whether to send BAR after missed BlockAck
-    std::size_t m_nMaxInflight;            ///< max number of links on which an MPDU can be inflight
-    std::size_t m_nPackets;                ///< number of application packets to generate
-    std::size_t m_blockAckCount{0};        ///< transmitted BlockAck counter
-    std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
-    std::array<std::size_t, 3> m_rxPkts{}; ///< number of packets received at application layer
-                                           ///< by each node (AP, STA 0, STA 1)
+    RxErrorModelMap m_errorModels;       ///< error rate models to corrupt packets
+    std::list<uint64_t> m_uidList;       ///< list of UIDs of packets to corrupt
+    bool m_dataCorrupted{false};         ///< whether second data frame has been already corrupted
+    WifiTrafficPattern m_trafficPattern; ///< the pattern of traffic to generate
+    bool m_baEnabled;                    ///< whether BA agreement is enabled or disabled
+    bool m_useBarAfterMissedBa;          ///< whether to send BAR after missed BlockAck
+    std::size_t m_nMaxInflight;          ///< max number of links on which an MPDU can be inflight
+    std::size_t m_nPackets;              ///< number of application packets to generate
+    std::size_t m_blockAckCount{0};      ///< transmitted BlockAck counter
+    std::size_t m_blockAckReqCount{0};   ///< transmitted BlockAckReq counter
     std::map<uint16_t, std::size_t> m_inflightCount; ///< seqNo-indexed max number of simultaneous
                                                      ///< transmissions of a data frame
     Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
 };
 
-MultiLinkTxTest::MultiLinkTxTest(WifiTrafficPattern trafficPattern,
+MultiLinkTxTest::MultiLinkTxTest(const BaseParams& baseParams,
+                                 WifiTrafficPattern trafficPattern,
                                  WifiBaEnabled baEnabled,
                                  WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                                 uint8_t nMaxInflight,
-                                 const std::vector<std::string>& staChannels,
-                                 const std::vector<std::string>& apChannels,
-                                 const std::vector<uint8_t>& fixedPhyBands)
+                                 uint8_t nMaxInflight)
     : MultiLinkOperationsTestBase(
           std::string("Check data transmission between MLDs ") +
               (baEnabled == WifiBaEnabled::YES
@@ -1237,9 +1880,7 @@
                                                : "") +
               ")",
           2,
-          staChannels,
-          apChannels,
-          fixedPhyBands),
+          baseParams),
       m_trafficPattern(trafficPattern),
       m_baEnabled(baEnabled == WifiBaEnabled::YES),
       m_useBarAfterMissedBa(useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES),
@@ -1252,12 +1893,15 @@
 }
 
 void
-MultiLinkTxTest::Transmit(uint8_t linkId,
-                          std::string context,
+MultiLinkTxTest::Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
                           WifiConstPsduMap psduMap,
                           WifiTxVector txVector,
                           double txPowerW)
 {
+    MultiLinkOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
     auto psdu = psduMap.begin()->second;
 
     switch (psdu->GetHeader(0).GetType())
@@ -1282,7 +1926,7 @@
         {
             // determine the max number of simultaneous transmissions for this MPDU
             // (only if sent by the traffic source and this is not a broadcast frame)
-            if (m_baEnabled && linkId < m_sourceMac->GetNLinks() &&
+            if (m_baEnabled && m_sourceMac->GetLinkIds().count(linkId) == 1 &&
                 m_sourceMac->GetFrameExchangeManager(linkId)->GetAddress() ==
                     mpdu->GetHeader().GetAddr2() &&
                 !mpdu->GetHeader().GetAddr1().IsGroup())
@@ -1361,8 +2005,6 @@
     }
     default:;
     }
-
-    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
 }
 
 void
@@ -1500,13 +2142,6 @@
 }
 
 void
-MultiLinkTxTest::L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr)
-{
-    NS_LOG_INFO("Packet received by NODE " << +nodeId << "\n");
-    m_rxPkts[nodeId]++;
-}
-
-void
 MultiLinkTxTest::DoSetup()
 {
     MultiLinkOperationsTestBase::DoSetup();
@@ -1530,22 +2165,20 @@
         m_errorModels[m_apMac->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
         m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
     }
-    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    for (std::size_t i : {0, 1})
     {
-        auto errorModel = CreateObject<ListErrorModel>();
-        m_errorModels[m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
-        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
-
-        errorModel = CreateObject<ListErrorModel>();
-        m_errorModels[m_staMacs[1]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
-        m_staMacs[1]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+        for (const auto linkId : m_staMacs[i]->GetLinkIds())
+        {
+            auto errorModel = CreateObject<ListErrorModel>();
+            m_errorModels[m_staMacs[i]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+            m_staMacs[i]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+        }
     }
 }
 
 void
 MultiLinkTxTest::StartTraffic()
 {
-    const Time duration = Seconds(1);
     Address destAddr;
 
     switch (m_trafficPattern)
@@ -1572,58 +2205,24 @@
         break;
     }
 
-    PacketSocketHelper packetSocket;
-    packetSocket.Install(m_apMac->GetDevice()->GetNode());
-    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
-    packetSocket.Install(m_staMacs[1]->GetDevice()->GetNode());
-
-    PacketSocketAddress socket;
-    socket.SetSingleDevice(m_sourceMac->GetDevice()->GetIfIndex());
-    socket.SetPhysicalAddress(destAddr);
-    socket.SetProtocol(1);
+    PacketSocketAddress sockAddr;
+    sockAddr.SetSingleDevice(m_sourceMac->GetDevice()->GetIfIndex());
+    sockAddr.SetPhysicalAddress(destAddr);
+    sockAddr.SetProtocol(1);
 
     // install first client application generating at most 4 packets
-    auto client1 = CreateObject<PacketSocketClient>();
-    client1->SetAttribute("PacketSize", UintegerValue(1000));
-    client1->SetAttribute("MaxPackets", UintegerValue(std::min<std::size_t>(m_nPackets, 4)));
-    client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-    client1->SetRemote(socket);
-    m_sourceMac->GetDevice()->GetNode()->AddApplication(client1);
-    client1->SetStartTime(Seconds(0)); // now
-    client1->SetStopTime(duration);
+    m_sourceMac->GetDevice()->GetNode()->AddApplication(
+        GetApplication(sockAddr, std::min<std::size_t>(m_nPackets, 4), 1000));
 
     if (m_nPackets > 4)
     {
-        // install a second client application generating the remaining packets
-        auto client2 = CreateObject<PacketSocketClient>();
-        client2->SetAttribute("PacketSize", UintegerValue(1000));
-        client2->SetAttribute("MaxPackets", UintegerValue(m_nPackets - 4));
-        client2->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-        client2->SetRemote(socket);
-        m_sourceMac->GetDevice()->GetNode()->AddApplication(client2);
-        // start during transmission of first A-MPDU, if multiple links are setup
-        client2->SetStartTime(MilliSeconds(4));
-        client2->SetStopTime(duration);
-    }
-
-    // install a server on all nodes
-    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
-    {
-        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
-        server->SetLocal(socket);
-        (*nodeIt)->AddApplication(server);
-        server->SetStartTime(Seconds(0)); // now
-        server->SetStopTime(duration);
+        // install a second client application generating the remaining packets and
+        // starting during transmission of first A-MPDU, if multiple links are setup
+        m_sourceMac->GetDevice()->GetNode()->AddApplication(
+            GetApplication(sockAddr, m_nPackets - 4, 1000, MilliSeconds(4)));
     }
 
-    for (std::size_t nodeId = 0; nodeId < NodeList::GetNNodes(); nodeId++)
-    {
-        Config::ConnectWithoutContext("/NodeList/" + std::to_string(nodeId) +
-                                          "/ApplicationList/*/$ns3::PacketSocketServer/Rx",
-                                      MakeCallback(&MultiLinkTxTest::L7Receive, this).Bind(nodeId));
-    }
-
-    Simulator::Stop(duration);
+    Simulator::Stop(m_duration);
 }
 
 void
